import type { ComponentType } from 'react';
export declare type GoodPageCache = {
    page: ComponentType;
    mod: any;
};
export declare type PageCacheEntry = {
    error: any;
} | GoodPageCache;
export default class PageLoader {
    private buildId;
    private assetPrefix;
    private pageCache;
    private pageRegisterEvents;
    private loadingRoutes;
    private promisedBuildManifest?;
    private promisedSsgManifest?;
    private promisedDevPagesManifest?;
    constructor(buildId: string, assetPrefix: string, initialPage: string);
    getPageList(): any;
    getDependencies(route: string): Promise<string[]>;
    /**
     * @param {string} href the route href (file-system path)
     * @param {string} asPath the URL as shown in browser (virtual path); used for dynamic routes
     */
    getDataHref(href: string, asPath: string, ssg: boolean): string | undefined;
    /**
     * @param {string} href the route href (file-system path)
     * @param {string} asPath the URL as shown in browser (virtual path); used for dynamic routes
     */
    prefetchData(href: string, asPath: string): Promise<void>;
    loadPage(route: string): Promise<GoodPageCache>;
    loadScript(url: string, route: string): void;
    registerPage(route: string, regFn: () => any): void;
    /**
     * @param {string} route
     * @param {boolean} [isDependency]
     */
    prefetch(route: string, isDependency?: boolean): Promise<void>;
}
